unit CoreIntf;

interface

uses Classes, SysUtils;

const
  {Notification constatnts}
  CAPPSTARTNOTIF = 0;
  CAPPCLOSENOTIF = 1;

Type
  TAuxStringClassFunc = function: string of object;
  TAuxBoolClassFunc = function: boolean of object;

  IEventNotifier = interface (IInterface)
   ['{277DAA77-7775-11D1-ABA7-74444FB17472}']
   procedure Execute(AParam: pointer); cdecl;
  end;

  ICoreLibrary = interface (IInterface)
    ['{28ADAA8A-B875-11D1-ABA7-70C04FB17A72}']
    function LibCount: integer; cdecl;
    function LibName(index: integer; ABuf: pointer; ASize: Cardinal): cardinal; cdecl;
    function LibInstance(index: integer): cardinal; cdecl;
    function AddLib(ALibName: PChar): integer; cdecl;
    procedure FreeLib(AIndex: integer); cdecl;

    function ExportCount(ALibIndex: integer): integer; cdecl;
    function ExportName(ALibIndex, AExpIndex: integer; ABuf: pointer; ASize: Cardinal): cardinal; cdecl;
    function ExportAddr(ALibIndex, AExpIndex: integer): pointer; cdecl;

    {IComponentCreate}
    function ClassCount: integer; cdecl;
    function ClassUnitName(AClassIndex: integer; ABuf: pointer; ASize: cardinal): cardinal; cdecl;
    function ClassName(AClassIndex: integer; ABuf: pointer; ASize: Cardinal): cardinal; cdecl;
    function ClassAddr(AClassIndex: integer): Pointer; cdecl;
    function ClassLibIndex(AClassIndex: Integer): integer; cdecl;
    function GetMethodsCount(AClassIndex: integer): integer; cdecl;
    function GetMethodName(AClassIndex, AMethIndex: integer; ABuf: pointer; ASize: Cardinal): cardinal; cdecl;
    function GetMethodAddr(AClassIndex, AMethIndex: integer): pointer; cdecl;
    //function FindResource(ALibIndex: integer; AResName: PChar): cardinal; cdecl;
    function ReadResource(ALibIndex: integer; AResName: PChar; ABuf: pointer; ASize: Int64): Int64; cdecl;

    function CreateComponent(ACompClassName: PChar):Pointer; cdecl;
    function CreateComponentIdx(ACompClassIndex: integer):Pointer; cdecl;
    function CheckProperty(AComponent: pointer; APropName: PChar): boolean; cdecl;
    function GetPropValue(AComponent: pointer; APropName: PChar; AValue:PChar; AValueSize: integer): integer; cdecl;
    {IComponentTuner}
    procedure AppendRules(ARules: PChar); cdecl;
    function IsClass(AClass: pointer; AClassName: PChar): boolean; cdecl;
    procedure OwnerTuning(AObject: pointer); cdecl;
    {ILoaderCore}
    function GetApplicationHandle: cardinal; cdecl;
    function GetApplicationInstance: TObject; cdecl;
    function GetMainForm: TObject; cdecl;
    function GetFormCount: integer; cdecl;
    function GetForm(Index: integer): pointer; cdecl;
    function GetActiveFormIndex: integer; cdecl;

    procedure DeleteAppNotif(Notif: IEventNotifier); cdecl;
  end;

  TRegisterLibrary = procedure( AP1, AP2, AP3, AP4, AP5, AP6, AP7: pointer); cdecl;
  TUnregisterLibrary = procedure(AP1: pointer); cdecl;

var
  CoreLibrary: ICoreLibrary = nil;
implementation

end.
