{***************************************************************}
{                                                               }
{          Componet property editors for DBFormActn             }
{      mail over http http://visualdesigner.fatal.ru            }
{    http://visualdesigner.fatal.ru/                            }
{    Copyright (c) 2000-2003 Pfaffenrot S.                      }
{ ------------------------------------------------------------- }
{            home page      : http://VisulDesigner.fatal.ru/    }
{ ------------------------------------------------------------- }
{***************************************************************}
unit UPkgRegUtl;

interface

procedure Register;

implementation

uses Windows, Classes, ActnList, DBFrmActn, DesignIntf, DesignEditors, Dialogs
  , ToolsAPI, Menus, CoreIntf, SysUtils, Forms, TypInfo, StdCtrls, ExtCtrls,
  Controls{, UfrmListDialog}, DB, INIFiles, Registry, UWzds, UfrmOptions
;

const
  cUnRegLib                 = 'UNREGISTERLIBRARY';
  cGetCapt                  = 'GETCAPTION';
  cGetMenuPath              = 'GETMENUPATH';
  cCreaNec                  = 'CREATENECESSARY';
  cRegLib                   = 'REGISTERLIBRARY';
  cDataSet                  = 'DataSet';
  cGetDataSet               = 'GetDataSet';
  cSetDataSet               = 'SetDataSet';
  cGetField                 = 'GetFieldName';
  cSetField                 = 'SetFieldName';
  cSecTuning                = 'Tuning';
  cDot: Char                = '.';
  cRegPath                  = 'SOFTWARE\SVD\DLL-Manager';
  cRegLoaderPath            = 'LoaderPath';
  cRegLastINI               = 'LastINI';
  cRegEditors               = 'Editors';

resourcestring
  sInvalidPropertyValue = 'Invalid Property Value';
  sRegLibError = 'Registration of library has been exception.';
  sUnRegLibError = 'Dispose of library has been exception.';

type
  TDataSetPropEditor = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;
  TFormPropEditor = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;
  TFieldsPropEditor = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  TUniCompProp = class(TComponentProperty)
  protected
    function _GetPropClassName: TClass;
  public
    procedure GetValues(Proc: TGetStrProc); override;
    function GetAttributes: TPropertyAttributes; override;
    procedure SetValue(const Value: string); override;
  end;

  TMainMenuItem = class(TMenuItem)
  private
    FModules: TList;
    FTunList: TStringList;
    FCoreHInst: cardinal;
    FCore: ICoreLibrary;
    CheckItem: TMenuItem;
    Options: TMenuItem;
    FIniFileName: TFileName;
    FLoaderPath: TFileName;
    FEditorsList: TStringList;
    FModLoadMistake: string;
    FModFileName: string;
    FClassUnitName: string;
  protected
    function _ClassName(AClass: TClass): string;
  public
    procedure OpenCloseCore(Sender: TObject);
    procedure AddLibrary(Sender: TObject);
    //procedure DelLibrary(Sender: TObject);
    procedure SetIniFileName(Sender: TObject);
    procedure CreateNewProject(Sender: TObject);
    procedure CreateNewForm(Sender: TObject);
    procedure CreateNewDM(Sender: TObject);
    procedure SetLoaderPath(Sender: TObject);
    procedure ShowOptions(Sender: TObject);

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure CreateComp(Sender: TObject);
    procedure InitLibs(AIndex: integer);
    procedure LoadLib(ALibName: string);
    procedure IntFreeLibrary(AIndex: integer);

    procedure GetComponentList(AList: TStrings; AClass: TClass);
    procedure ProcessIniFile(AFileName: TFileName; ASave: boolean = False);
    procedure ProcessLoaderPath(AFileName: TFileName);

    function ModuleFromLib(ACompClass: TClass; ALibIndex: Integer): boolean;
    function GetMistakes: string;

    procedure RegisterPropEditor(CompClassName, PropertyName: string);
    procedure ReadRegistry;
    procedure WriteRegistry;
  end;

  TCP = procedure(A, B, C: pointer); stdcall;


procedure Register;
begin      (*      *)
  RegisterActions(cDataSet, [TDBFormAction], nil);
  RegisterPropertyEditor(TypeInfo(TComponentName), TDBNode, cGetDataSet, TDataSetPropEditor);
  RegisterPropertyEditor(TypeInfo(TComponentName), TDBNode, cSetDataSet, TDataSetPropEditor);
  RegisterPropertyEditor(TypeInfo(TComponentName), TODSItem, 'DataSetName', TDataSetPropEditor);
  RegisterPropertyEditor(TypeInfo(TComponentName), TDBNode, cSetField, TFieldsPropEditor);
  RegisterPropertyEditor(TypeInfo(TComponentName), TDBNode, cGetField, TFieldsPropEditor);
  RegisterPropertyEditor(TypeInfo(TComponentName), TDBFormAction, 'DestFormName', TFormPropEditor);

  TMainMenuItem.Create(nil);
end;

function _RegClass(AClass: TClass): TClass; stdcall;
var S : string;
begin
  S := AClass.ClassName;
  Result := GetClass(S);
end;

var
  MainMenuItem: TMainMenuItem  = nil;

{ TFormPropEditor }

function TFormPropEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList]//[paDialog];
end;

procedure TFormPropEditor.GetValues(Proc: TGetStrProc);
var L : TStringList; i, j : integer; S,C : string; M : IOTAModuleServices; P: IOTAProject;
begin
  L := TStringList.Create;
  try
    inherited GetValues(Proc);

    C := TForm.ClassName;
    MainMenuItem.GetComponentList(L, TForm);
    for i := 0 to L.Count - 1 do
      L[i] := MainMenuItem._ClassName((L.Objects[i]).ClassType);
    if MainMenuItem.FCore <> nil then
    for i := 0 to MainMenuItem.FCore.ClassCount -1 do
    if MainMenuItem.FCore.IsClass(MainMenuItem.FCore.ClassAddr(i), PChar(C)) then    
    begin
      //S := MainMenuItem._ClassName(
      j :=MainMenuItem.FCore.ClassName(i, nil, 0 );
      SetLength(S, j);
      MainMenuItem.FCore.ClassName(i, PChar(S), j );
      if L.IndexOf(S) < 0 then
        L.Add(S);
    end;

    if Supports(BorlandIDEServices, IOTAModuleServices, M) then
    for i := 0 to M.ModuleCount - 1 do
    if Supports(M.Modules[i], IOTAProject, P) then
      for j := 0 to P.GetModuleCount - 1 do
        if Length(P.GetModule(j).FormName) >0  then
        if Length(P.GetModule(j).DesignClass) =0  then
          L.Add('T' + P.GetModule(j).FormName);


    for i := 0 to L.Count - 1 do
      Proc(L[i]);
  finally
    L.Free;
  end;
end;

{ TDataSetPropEditor }

function TDataSetPropEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList]//[paDialog];
end;

procedure TDataSetPropEditor.GetValues(Proc: TGetStrProc);
var L : TStringList; i : integer;
begin
  L := TStringList.Create;
  try
    inherited GetValues(Proc);
    MainMenuItem.GetComponentList(L, TDataSet);
    for i := 0 to L.Count - 1 do
      Proc(L[i]);
  finally
    L.Free;
  end;
end;

{ TMainMenuItem }

procedure TMainMenuItem.AddLibrary(Sender: TObject);
begin
  with TOpenDialog.Create(nil) do
  try
    //Caption := 'Open library';
    Filter := '*.dll|*.dll';
    DefaultExt := 'DLL';
    if Execute then
       LoadLib(FileName);
  finally
    Free
  end;
end;

constructor TMainMenuItem.Create(AOwner: TComponent);
var MM : TMainMenu; i,j : integer; S,CN,PN : string;
  procedure AddSubMenu(MenuCaption: string; ANotify: TNotifyEvent);
  var M : TMenuItem;
  begin
    M := TMenuItem.Create(Self);  
    M.OnClick := ANotify;
    M.Caption := MenuCaption;
    M.Enabled := True;
    Add(M);
  end;
begin
  inherited;
  FCore := nil;

  FCoreHInst := 0;
  MainMenuItem := Self;
  Self.Caption := 'DLL Manager';
  MM := (BorlandIDEServices as INTAServices40).MainMenu;
  MM.Items.Insert(MM.Items.Count -2, Self);
  FEditorsList := TStringList.Create;
  FModules := TList.Create;
  FTunList := TStringList.Create;

  CheckItem := TMenuItem.Create(Self);
  CheckItem.OnClick := OpenCloseCore;
  CheckItem.Caption := 'Run/Stop wizard';
  Add(CheckItem);
  AddSubMenu('-', nil);

  Options := TMenuItem.Create(Self);
  Options.OnClick := ShowOptions;
  Options.Caption := 'Options';
  //Options.Enabled := False;
  Add(Options);

  AddSubMenu('-', nil);
  AddSubMenu('Create new DLL-project', CreateNewProject);
  AddSubMenu('Create new Form', CreateNewForm);
  AddSubMenu('Create new DataModule', CreateNewDM);

  ReadRegistry;
  ProcessIniFile(FIniFileName);

  FCoreHInst := 0;
end;


procedure TMainMenuItem.CreateComp(Sender: TObject);
begin
  FModules.Add(Sender);
end;

procedure TMainMenuItem.CreateNewDM(Sender: TObject);
var
  CP : TCP;
begin
  @CP := GetProcAddress(HInstance, 'CM');
  if Assigned(CP) then
    CP(pointer(BorlandIDEServices), pointer(1), pointer(GetActiveProject));
end;

procedure TMainMenuItem.CreateNewForm(Sender: TObject);
var
  CP : TCP;
begin
  @CP := GetProcAddress(HInstance, 'CM');
  if Assigned(CP) then
    CP(pointer(BorlandIDEServices), nil, pointer(GetActiveProject));
end;

procedure TMainMenuItem.CreateNewProject(Sender: TObject);
var
  CP : TCP;
begin
  @CP := GetProcAddress(HInstance, 'CP');
  if Assigned(CP) then
    CP(pointer(BorlandIDEServices), PChar(FLoaderPath), PChar(FIniFileName));
end;

destructor TMainMenuItem.Destroy;
var i : integer;
begin
  ProcessIniFile(FIniFileName, True);
  MainMenuItem := nil;
  FEditorsList.Free;
  FTunList.Free;

  if FCore <> nil then
  for i := FCore.LibCount - 1 downto 0 do
    IntFreeLibrary(i);

  FModules.Free;

  FCore := nil;

  inherited;
end;


procedure TMainMenuItem.IntFreeLibrary(AIndex: integer);
var i,j, k : integer; O : TObject; S : string;
begin
  for i := FModules.Count - 1 downto 0 do
  try
    O := TObject(FModules[i]);

    if ModuleFromLib(O.ClassType, AIndex) then
    try
      S := TDataModule.ClassName;
      if (FCore.IsClass(O.ClassType, PChar(S))) then
        RemoveDataModule(TDataModule(O));
      O.Free;
    finally
      FModules.Delete(i);
    end;
  except
  end;
  {Library Unregistration}
  j := length(cUnRegLib);
  for i := 0 to FCore.ExportCount(AIndex) - 1 do
  begin
    k := FCore.ExportName(AIndex, i, nil, 0);
    SetLength(S, K);
    k := FCore.ExportName(AIndex, i, PChar(S), K);
    if k < j then Continue;
    if (cUnRegLib = S) then
    try
      TUnregisterLibrary(FCore.ExportAddr(AIndex, i))(@FCore);
    except
      ShowMessage(sUnRegLibError);
    end;
  end;
  {}
  FCore.FreeLib(AIndex);
end;

procedure TMainMenuItem.GetComponentList(AList: TStrings; AClass: TClass);
var i,j : integer; Own: TComponent;  LoadCore: boolean; ACN : string;

  procedure AddList(AComp: TComponent);
  begin
      if LoadCore then
      begin
        if FCore.IsClass(AComp.ClassType, PChar(ACN)) then
        begin
          if AList.IndexOfObject(AComp) < 0 then
            AList.AddObject(AComp.Owner.Name + cDot + AComp.Name, AComp);
        end
      end
      else
      if (AComp is AClass) then
      if AList.IndexOfObject(AComp) < 0 then
        AList.AddObject(AComp.Owner.Name + cDot + AComp.Name, AComp);
  end;

begin
  LoadCore := MainMenuItem.FCoreHInst <> 0;
  ACN := AClass.ClassName;
  {for modules}
  if LoadCore then
  for i := 0 to FModules.Count - 1 do
  begin
    Own := TComponent(FModules[i]);
    for j := 0 to Own.ComponentCount - 1 do
      AddList(TComponent(Own.Components[j]));
  end;
  {}
  for i := 0 to Application.ComponentCount - 1 do
  begin
    Own := TComponent(Application.Components[i]);
    for j := 0 to Own.ComponentCount - 1 do
      AddList(TComponent(Own.Components[j]));
  end;
  {}
  for i := 0 to Screen.FormCount - 1 do
  begin
    Own := TComponent(Screen.Forms[i]);
    for j := 0 to Own.ComponentCount - 1 do
      AddList(TComponent(Own.Components[j]));
  end;
  {}
  for i := 0 to Screen.DataModuleCount - 1 do
  begin
    Own := TComponent(Screen.DataModules[i]);
    for j := 0 to Own.ComponentCount - 1 do
      AddList(TComponent(Own.Components[j]));
  end;
end;

type THC = class(TComponent);
     TC = function: boolean of object;
procedure TMainMenuItem.InitLibs(AIndex: integer);
var i, j, CI: integer; C : TClass;
    St2, UN, sDM, sFrm: string;
    P : PChar;
    Cpnt: TComponent;
    Fnc : TC;
    RS: Int64;
    procedure CreateMistake;
    begin
      CI := FCore.LibName(AIndex, nil, 0);
      SetLength(St2, CI);
      CI := FCore.LibName(AIndex, PChar(St2), CI);

      CI := FCore.ClassUnitName(i, nil, 0);
      SetLength(UN, CI);
      CI := FCore.ClassUnitName(i, PChar(UN), CI);

      St2 := 'Exception of creation: ' + string(PChar(UN))
      + '.pas with class ' + _ClassName(C) + '.Create()' +#13#10
      + 'for library ' +ExtractFileName(String(PChar(St2))) + #13#10
      ;
    end;
    function IsChild(AClass, AEtal:TClass): boolean;
    var
      AEtalName: string;
    begin
      AEtalName := _ClassName(AEtal);
      Result := _ClassName(AClass) <> AEtalName;
      if Result then
        Result := FCore.IsClass(AClass, PChar(AEtalName));
    end;
begin
  {Find form from library}
  sDM := TComponent.ClassName;
  //sFrm := TForm.ClassName;
  for I := 0 to FCore.ClassCount - 1 do
  begin
  CI := FCore.ClassLibIndex(i);
  if CI = AIndex then
  begin
    C := TClass(FCore.ClassAddr(i));
    if IsChild(C, TComponent) then
    begin
      for j := 0 to FCore.GetMethodsCount(i) - 1 do
      begin
        CI := FCore.GetMethodName(i, j, nil, 0);
        SetLength(St2, CI);
        CI := FCore.GetMethodName(i, j, PChar(St2), CI);
        St2 := UpperCase(String(PChar(St2)));
        @Fnc := FCore.GetMethodAddr(i, j);
        if (St2 = cCreaNec{CreateNecessary}) then
        if Fnc then
        begin
          try
            Rs := 2;
            if IsChild(C, TDataModule) or IsChild(C, TForm) then
            begin {Check the resource for TDataModule and TForm}
              sFrm := _ClassName(C);
              Rs := FCore.ReadResource(AIndex, PChar(sFrm), nil, 0);
              if Rs < 0 then
              begin
                sFrm := UpperCase(sFrm);
                Rs := FCore.ReadResource(AIndex, PChar(sFrm), nil, 0);
              end;
              if Rs < 1 then
              begin
                CreateMistake;
                St2 := St2 + ' not found resource';
                FModLoadMistake := FModLoadMistake + #13#10
                 + St2;
              end;
            end;
            Cpnt := nil;
            if Rs > 1 then
            begin

              Cpnt := TComponentClass(C).Create(Application);

              //Cpnt .Create(Application);
            end;
          except on E: Exception do
            begin
               CreateMistake;
               St2 := St2 + E.Message;

              FModLoadMistake := FModLoadMistake + #13#10
              + St2;
              //ShowMessage(St2);
            end;
          end;
          if Cpnt <> nil then
          begin
              System.Delete(sFrm, 1, 1);
              Cpnt.Name := sFrm;
              FModules.Add(Cpnt);
          end;
//              if FCore.IsClass(C, PChar(sDM)) then
//              if Assigned(AddDataModule) then
//                AddDataModule(TDataModule(Cpnt));
        end;
      end; {for TDataModule}
    end;{if}

  end; {for classes}
  end;
  {end of  Find form}
end;

procedure TMainMenuItem.LoadLib(ALibName: string);
var
  i, j, k, AIndex, Cnt : integer;
  P1,P2,P3,P4,P5,P6,P7,Ptr: pointer;
  S : string;
begin
  if FileExists(ALibName) then
  begin
    FModFileName := ExtractFileName(ALibName);
    for i := 0 to FCore.LibCount - 1 do
    begin
      j := length(ALibName);
      k := FCore.LibName(i, nil, 0);
      SetLength(S, k);
      k := FCore.LibName(i, PChar(S), k);
      if (ALibName = S) then
      //if FCore.LibName[i].FileName = ALibName then
        Exit;
    end;

    AIndex := FCore.AddLib(PChar(ALibName));

    j := length(cRegLib);
    Cnt := FCore.ExportCount(AIndex);
    for i := 0 to Cnt - 1 do
    begin
      k := FCore.ExportName(AIndex, i, nil, 0);
      SetLength(S, k);
      k := FCore.ExportName(AIndex, i, PChar(S), k);
      if (cRegLib = S) then
      try
        Ptr := FCore.ExportAddr(AIndex, i);
        P1 := pointer(Application.Handle);
        P1 := Application;
        P1 := pointer(FCore);
        P1 := @Screen;
        P1 := pointer(GlobalNameSpace);
        P1 := @AddDataModule;
        P1 := @RemoveDataModule;
        TRegisterLibrary(Ptr)(P1, P2, P3, P4, P5, P6, P7);

        InitLibs(AIndex);
      except on E: Exception do
        begin
          FCore.FreeLib(AIndex);
          FModLoadMistake := FModLoadMistake + 'Can''t register library ' + FModFileName
          + #13#10 + E.Message;
        end;
      end;
    end;     
  end;
end;

function TMainMenuItem.ModuleFromLib(ACompClass: TClass; ALibIndex: Integer): boolean;
var
  i : integer;
begin
  Result := False;
  for i := 0 to FCore.ClassCount - 1 do
    if FCore.ClassAddr(i) = ACompClass then
    if FCore.ClassLibIndex(i) = ALibIndex then
    begin
      Result := True;
      Exit;
    end;
end;

procedure TMainMenuItem.OpenCloseCore(Sender: TObject);
type
  TInit = procedure(A: pointer; B: cardinal; c: pointer; var ACL: ICoreLibrary);  stdcall;
  TRW = function(A: Pointer): integer; stdcall;
var P : TMenuItem; i : integer; S : string;
    Check : boolean;  Ptr : TInit; P1,P3, Pr: pointer; C: Cardinal;
begin
  Check := not CheckItem.Checked;

  try
    if Check then
    try  //{$C+}{$D+}{$Y+}{$L+}
      SetLength(FIniFileName, 0);
      i := 100;
      SetLength(S,  i);
      C := GetModuleFileName(HInstance, PChar(S), i);
      if C > i then
      begin
        i := C;
        SetLength(S, i + 1);
        GetModuleFileName(HInstance, PChar(S), i);
      end;
      C :=Forms.Application.Handle;
      P1 := Forms.Application;
      P3 := Forms.Application.MainForm;

      S := ExtractFilePath(S);
      S := S + 'coreidew1.dll';
      Check := False;
      FCore := nil;
      if FileExists(S) then
      begin
        FCoreHInst := LoadLibrary(PChar(S));

        Ptr := GetProcAddress(FCoreHInst, 'F1');
        if Assigned(Ptr) then
          Ptr(P1, C, P3, FCore);
      end;
      Check := Assigned(FCore);

      {libraries load from INI}
    finally
    end
    else
    try
      for i := FCore.LibCount -1 downto 0 do
        IntFreeLibrary(i);

      FCore := nil;
      FreeLibrary(FCoreHInst);
      FCoreHInst := 0;
    finally
    end;
  finally
    CheckItem.Checked := Check;
    Options.Enabled := Check;
  end    //{$C-}{$D-}{$Y-}{$L-}
end;

procedure TMainMenuItem.ProcessIniFile(AFileName: TFileName; ASave: Boolean = False);
var INI : TIniFile; i : integer;
begin
  if (FIniFileName <> AFileName)or ASave then
  begin
    if Length(FIniFileName) > 0 then
    try
      INI := TIniFile.Create(FIniFileName);

      for i := 0 to FTunList.Count - 1 do
      if (Length(FTunList.Names[i]) >0)and(Length(FTunList.Values[FTunList.Names[i]]) >0)and(Length(cSecTuning) >0) then

        INI.WriteString(cSecTuning, FTunList.Names[i], FTunList.Values[FTunList.Names[i]]);
    finally
      INI.Free;
    end;
  end;
  if (FIniFileName <> AFileName) then
  if FTunList <> nil then
  begin
    FIniFileName := AFileName;
    try
      INI := TIniFile.Create(FIniFileName);
      INI.ReadSection(cSecTuning, FTunList);
    finally
      INI.Free;
    end;
  end;
end;

procedure TMainMenuItem.ProcessLoaderPath(AFileName: TFileName);
begin
  FLoaderPath := AFileName;
  with TRegistry.Create do
  try
    OpenKey(cRegPath, True);
    WriteString(cRegLoaderPath, FLoaderPath);
  finally
    Free;
  end;
end;

procedure TMainMenuItem.ReadRegistry;
var
  i, j : integer;
  s, PN, CN : string;
begin
  with TRegistry.Create do
  try
    OpenKey(cRegPath, True);
    if ValueExists(cRegLoaderPath) then
      FLoaderPath := ReadString(cRegLoaderPath);
    if ValueExists(cRegLastINI) then
      FIniFileName := ReadString(cRegLastINI);

    i :=  GetDataSize(cRegEditors);
    if i > 0 then
    begin
      SetLength(S, i);
      ReadBinaryData(cRegEditors, pointer(S)^, i);
    end;
    if i <= 0 then
    begin
      FEditorsList.Add(TDataSource.ClassName + cDot + cDataSet);
    end;

    FEditorsList.Text := S;
    SetLength(S, 0);
    i := FEditorsList.Count;
    while (i>0) do
    begin
      S := FEditorsList[0];
      FEditorsList.Delete(0);

      j := pos(cDot, S);
      PN := copy(S, j +1, length(S));
      CN := copy(S, 1, j -1);
      RegisterPropEditor(CN, PN);
      dec(i);
    end;
  finally
    Free;
  end;
end;

procedure TMainMenuItem.RegisterPropEditor(CompClassName, PropertyName: string);
var S : string; PropertyType: PTypeInfo;  PI: PPropInfo; C : TPersistentClass;
begin
  C := GetClass(CompClassName);
  if C <> nil then
    PI := GetPropInfo(PTypeInfo(C.ClassInfo), PropertyName);
  if PI <> nil then
  begin
    PropertyName := PI^.Name;
    PropertyType := PI^.PropType^;
    S := C.ClassName;
    S := S + cDot + PropertyName;
    if FEditorsList.IndexOf(S) < 0 then
    begin
      RegisterPropertyEditor(PropertyType, C, PropertyName, TUniCompProp);
    end;
  end
  else
    S := CompClassName + cDot + PropertyName;
  FEditorsList.Add(S);
end;

procedure TMainMenuItem.SetIniFileName(Sender: TObject);
begin
  with TOpenDialog.Create(nil) do
  try
    //Caption := 'Open library';
    Filter := '*.ini|*.ini';
    DefaultExt := 'INI';
    if Execute then
       ProcessIniFile(FileName);
  finally
    Free
  end;
end;

procedure TMainMenuItem.SetLoaderPath(Sender: TObject);
begin

end;

procedure TMainMenuItem.ShowOptions(Sender: TObject);
var frmOptions: TfrmOptions; i,k : integer; S: String;
begin
  frmOptions:= TfrmOptions.Create(Self);
  try
    SetLength(FModLoadMistake, 0);
    frmOptions.tsLibraries.Visible := FCore <> nil;
    frmOptions.MistakeMessage := GetMistakes;
    frmOptions.pcPages.ActivePageIndex := 0;
    if FCore <> nil then
    begin
      frmOptions.LoadLibrary := LoadLib;
      frmOptions.UnloadLibrary := IntFreeLibrary;
      frmOptions.Modules := FModules;
      frmOptions.ModuleFromLibrary := ModuleFromLib;
      i :=  FCore.LibCount;
      for i := 0 to FCore.LibCount - 1 do
      begin
        k := FCore.LibName(i, nil ,0);
        SetLength(S, k);
        k := FCore.LibName(i, PChar(S), k);
        frmOptions.AddLibraryInList(i, S);
      end;
    end
    else
    begin
      //frmOptions.tsLibraries.Visible := False;
      frmOptions.tsLibraries.Enabled := False;
    end;

    frmOptions.RegPropEditor := RegisterPropEditor;
    frmOptions.EditorList := FEditorsList;
    frmOptions.RegPath := PChar(cRegPath);
    frmOptions.RegValue := PChar(cRegEditors);

    frmOptions.LoaderPath := @FLoaderPath;
    frmOptions.IniPath := @FIniFileName;
    frmOptions.RegLoaderValue := PChar(cRegLoaderPath);
    frmOptions.RegIniValue := PChar(cRegLastINI);

    if frmOptions.ShowModal = mrOk then
    begin
      ProcessIniFile(frmOptions.eIniFilePath.Text);
      FLoaderPath := frmOptions.eLoaderPath.Text;
      WriteRegistry;
    end;
  finally
    frmOptions.Free;
  end;
//except on E: Exception do
//end;

end;

procedure TMainMenuItem.WriteRegistry;
var
  s : string;
begin
  with TRegistry.Create do
  try
    OpenKey(cRegPath, True);
    WriteString(cRegLastINI, FIniFileName);

    WriteString(cRegLoaderPath, FLoaderPath);

    OpenKey(string(cRegEditors), True);
    S := FEditorsList.Text;
    WriteBinaryData(string(cRegEditors), pointer(S)^, Length(S));

  finally
    Free;
  end;
end;

{ TDataSetCompProp }

function TUniCompProp.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TUniCompProp.GetValues(Proc: TGetStrProc);
var L : TStringList; i : integer; 
begin
  L := TStringList.Create;
  try
    inherited GetValues(Proc);
    MainMenuItem.GetComponentList(L, _GetPropClassName);
    for i := 0 to L.Count - 1 do
      Proc(L[i]);
  finally
    L.Free;
  end;
end;

procedure TUniCompProp.SetValue(const Value: string);
var
  Component: TComponent; L : TStringList;
  LoadCore: boolean;
  CN,ECN : string;
  O : TPersistent;
begin
  O := GetComponent(0);
  SetLength(ECN, 0);
  if O is TComponent then
  begin
    if not(O is TForm)or(O is TDataModule) then
      ECN := TComponent(O).Owner.ClassName + cDot;
    ECN := ECN + TComponent(O).Name + cDot + GetName;
    MainMenuItem.FTunList.Values[ECN] := Value;
    MainMenuItem.ProcessIniFile(MainMenuItem.FIniFileName, True);
  end;

  if Value = '' then
    Component := nil
  else
  begin
    Component := Designer.GetComponent(Value);
    SetLength(CN, 0);
    if Component <> nil then
    begin
      if Component.Owner <> nil  then
      if length(Component.Owner.Name) >0  then
         CN := Component.Owner.Name + cDot;
      CN := CN + Component.Name;
    end;

    CN := _GetPropClassName.ClassName;
    LoadCore := MainMenuItem.FCoreHInst <> 0;
    if LoadCore then
    if Component = nil then
    try
      L := TStringList.Create;
      MainMenuItem.GetComponentList(L, _GetPropClassName);
      Component := TComponent(L.Objects[L.IndexOf(Value)]);
    finally
      L.Free;
    end;
    if LoadCore then
    begin
      if not MainMenuItem.FCore.IsClass(Component.ClassType, PChar(CN)) then
        raise Exception.CreateRes(@sInvalidPropertyValue)
      else
      begin
        O := GetComponent(0);
        if O is TComponent then
        begin
          SetLength(CN, 0);
          if TComponent(O).Owner <> nil then
          if TComponent(O).Owner <> Application then
            CN := TComponent(O).Owner.ClassName;
          CN := CN + cDot + TComponent(O).Name +cDot + GetName;
        end;
      end;
    end
    else
    if not (Component is GetTypeData(GetPropType)^.ClassType) then
      raise Exception.CreateRes(@sInvalidPropertyValue);
  end;
  SetLength(CN, 0);
  if Component <> nil then
    SetOrdValue(LongInt(Component));
end;

function TUniCompProp._GetPropClassName: TClass;
begin
  Result := GetTypeData(GetPropType)^.ClassType;
end;

function TMainMenuItem._ClassName(AClass: TClass): string;
begin
  Result := PShortString(PPointer(Integer(AClass) + vmtClassName)^)^;
end;

function TMainMenuItem.GetMistakes: string;
begin
  Result := FModLoadMistake;
end;

{ TFieldsPropEditor }

function TFieldsPropEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TFieldsPropEditor.GetValues(Proc: TGetStrProc);
var L : TStringList; i : integer; CN: string; DS : TDataSet; O: TPersistent;
  PI : PPropInfo;
  procedure SetList;
  var i : integer;
  begin
    L.Clear;
    if DS.Active then
      for i := 0 to DS.FieldCount - 1 do
        L.Add(DS.Fields[i].FieldName)
    else
    if DS is TDataSet then
      DS.GetFieldNames(L);

    for i := 0 to L.Count - 1 do
      Proc(L[i]);
  end;
begin
  DS := nil;
  O  := GetComponent(0);
  if GetName[1] = 'S' then
    CN := cSetDataSet;
  if GetName[1] = 'G' then
    CN := cGetDataSet;
  PI := TypInfo.GetPropinfo(O, CN);
  CN := GetStrProp(O, PI);
  if Length(CN) = 0 then Exit;
  L := TStringList.Create;
  try
    MainMenuItem.GetComponentList(L, TDataSet);

    I := L.IndexOf(CN);
    if i > -1 then
      DS := TDataSet(L.Objects[i]);
    if MainMenuItem.FCoreHInst <> 0 then
    begin
      CN := TDataSet.ClassName;
      if MainMenuItem.FCore.IsClass(DS.ClassType, PChar(CN)) then
        SetList;
    end
    else
      if DS is TDataSet then
        SetList;
  finally
    SetLength(CN, 0);
    L.Free;
  end;
end;

initialization

 finalization
   if MainMenuItem <> nil then
     MainMenuItem.Free;

end.
