{***************************************************************}
{                                                               }
{                                                               }
{      mail over http http://visualdesigner.fatal.ru            }
{    http://visualdesigner.fatal.ru/                            }
{    Copyright (c) 2000-2003 Pfaffenrot S.                      }
{ ------------------------------------------------------------- }
{            home page      : http://VisulDesigner.fatal.ru/    }
{ ------------------------------------------------------------- }
{***************************************************************}
unit UfrmOptions;

{
    ?
      
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, TypInfo, Registry;

type
  TLoadLibrary = procedure(ALibName: String) of object;
  TUnloadLibrary = procedure(AIndex: integer) of object;
  TModuleFromLibrary = function (ACompClass: TClass; ALibIndex: Integer): boolean of object;
  TStrFunc = function: string of object;

  TRegisterPropEditor = procedure (CompClassName, PropertyName: string) of object;

  TfrmOptions = class(TForm)
    pnlbottom: TPanel;
    btnOk: TButton;
    pcPages: TPageControl;
    tsLibraries: TTabSheet;
    panLibBottom: TPanel;
    lvListLibrary: TListView;
    btnLibAdd: TButton;
    btnLibDel: TButton;
    lbLibExportModules: TListBox;
    tsProperties: TTabSheet;
    tsMisc: TTabSheet;
    Memo1: TMemo;
    pnlPropMngClient: TPanel;
    lvPropManagment: TListView;
    gbPropManAddProp: TGroupBox;
    ePMClassName: TEdit;
    lClass: TLabel;
    cbPMPropName: TComboBox;
    lPMPropName: TLabel;
    btnPMAddProp: TButton;
    mLoadMistake: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    eLoaderPath: TEdit;
    btnLoaderSelect: TButton;
    Label3: TLabel;
    eIniFilePath: TEdit;
    btnSelectIni: TButton;
    btnCancel: TButton;
    procedure btnLibAddClick(Sender: TObject);
    procedure btnLibDelClick(Sender: TObject);
    procedure lvListLibrarySelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure pcPagesChange(Sender: TObject);
    procedure ePMClassNameExit(Sender: TObject);
    procedure btnPMAddPropClick(Sender: TObject);
    procedure btnLoaderSelectClick(Sender: TObject);
    procedure btnSelectIniClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public {Libraries}
    Modules: TList;
    LoadLibrary: TLoadLibrary;
    UnloadLibrary: TUnloadLibrary;
    ModuleFromLibrary: TModuleFromLibrary;
    MistakeMessage: TStrFunc;
    procedure AddLibraryInList(AInd: integer; ALibPath: string);
  public {Properties}
    RegPropEditor: TRegisterPropEditor;
    EditorList: TStrings;
    RegPath: PChar;
    RegValue: PChar;
    class procedure SaveToReg(ARegPath, ARegVal: PChar; AList: TStrings);
    //procedure EnumClasses(AClass: TClass);
  public {Misc}
    LoaderPath: PString;
    IniPath : PString;
    RegLoaderValue, RegIniValue: PChar;
  end;

implementation

uses ToolsApi;

{$R *.dfm}

procedure TfrmOptions.AddLibraryInList(AInd: integer; ALibPath: string);
var LI: TListItem;
begin
  LI := lvListLibrary.Items.Add;
  LI.Data := pointer(AInd);
  LI.Caption := ChangeFileExt(ExtractFileName(ALibPath), '');
  LI.SubItems.Add(ALibPath);
end;

procedure TfrmOptions.btnLibAddClick(Sender: TObject);
begin
  mLoadMistake.Lines.Clear;
  with TOpenDialog.Create(nil) do
  try
    //Caption := 'Open library';
    Filter := '*.dll|*.dll';
    DefaultExt := 'DLL';
    if Execute then
    begin
       LoadLibrary(FileName);
       AddLibraryInList(lvListLibrary.Items.Count -1, FileName);
    end;
  finally
    Free;
    mLoadMistake.Lines.Text := MistakeMessage;
  end;
end;

procedure TfrmOptions.btnLibDelClick(Sender: TObject);
var i : integer;
begin
  i := lvListLibrary.ItemIndex;
  if i in [0..lvListLibrary.Items.Count -1] then
  begin
    UnloadLibrary(i);
    lvListLibrary.Items.Delete(i);
  end;
end;               

procedure TfrmOptions.btnLoaderSelectClick(Sender: TObject);
var
  R : TRegistry;
begin
  with TOpenDialog.Create(Self) do
  try
    FileName := eLoaderPath.Text;
    Filter := 'LoaderDLL|*LoaderDLL.exe';
    DefaultExt := 'EXE';
    if Execute then
    begin
      eLoaderPath.Text := FileName;
      R := TRegistry.Create;
      try
        R.OpenKey(string(RegPath), True);
        R.WriteString(String(RegLoaderValue), FileName);
      finally
        R.Free;
      end;
    end;
  finally

    Free;
  end;
end;

procedure TfrmOptions.btnPMAddPropClick(Sender: TObject);
var
  TI: PTypeInfo;
  i : integer;
  C: TClass;
begin
  C := TClass(ePMClassName.Tag);
  i := cbPMPropName.Items.IndexOf(cbPMPropName.Text);
  if i <0  then Exit;

  TI := PTypeInfo(cbPMPropName.Items.Objects[i]);
  RegPropEditor(C.ClassName, cbPMPropName.Text);
  pcPagesChange(Self);
  SaveToReg(RegPath, RegValue, EditorList );
end;

procedure TfrmOptions.btnSelectIniClick(Sender: TObject);
var
  R : TRegistry;
begin
  with TOpenDialog.Create(Self) do
  try
    FileName := eIniFilePath.Text;
    Filter := 'INI|*.ini';
    DefaultExt := 'ini';
    if Execute then
    begin
      eIniFilePath.Text := FileName;
      R := TRegistry.Create;
      try
        R.OpenKey(string(RegPath), True);
        R.WriteString(String(RegIniValue), FileName);
      finally
        R.Free;
      end;
    end;
  finally
    Free;
  end;
end;

//procedure TfrmOptions.EnumClasses(AClass: TClass);
//var LI: TListItem; S : string;
//begin
//  if AClass.ClassName = TComponent.ClassName then Exit;
//  if lvPropManagment.FindData(0, AClass, True, True) <> nil then Exit;
//
//  LI := lvPropManagment.Items.Add;
//  LI.Data := AClass;
//  LI.Caption := AClass.ClassName;
//  LI.Checked := GetClass(LI.Caption) <> nil;
//end;

procedure TfrmOptions.ePMClassNameExit(Sender: TObject);
var
  AClass: TPersistentClass;
  PL : PPropList;
  Cnt, i: integer;
begin
  AClass := GetClass(ePMClassName.Text);
  ePMClassName.Tag := integer(AClass);
  cbPMPropName.Items.Clear;
  cbPMPropName.Text := '';
  if AClass = nil then
  begin
    btnPMAddProp.Enabled := False;
    ePMClassName.Font.Color := clRed;
  end
  else
  try
    Cnt := GetPropList(PTypeInfo(AClass.ClassInfo), PL);
    for i := 0 to Cnt - 1 do
      if PL^[i].PropType^^.Kind = tkClass then
        cbPMPropName.Items.AddObject(PL^[i].Name, TObject(PL^[i].PropType^));
    cbPMPropName.ItemIndex := 0;
    btnPMAddProp.Enabled := True;
    ePMClassName.Font.Color := clBlue;
    ePMClassName.Text := AClass.ClassName;
  except
  end;
end;

procedure TfrmOptions.FormShow(Sender: TObject);
begin
  eLoaderPath.Text := LoaderPath^;
  eIniFilePath.Text := IniPath^;
end;

procedure TfrmOptions.lvListLibrarySelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var i,j : integer;
begin
  lbLibExportModules.Items.Clear;
  if Item <> nil then
  begin
    i := Item.Index;
    for j := 0 to Modules.Count - 1 do
      if ModuleFromLibrary(TObject(Modules[j]).ClassType, i) then
         lbLibExportModules.Items.AddObject(TComponent(Modules[j]).Name, Modules[j]);    
  end;

end;

procedure TfrmOptions.pcPagesChange(Sender: TObject);
var i,j : integer; S : string;  LI: TListItem;
begin
  if pcPages.ActivePage = tsProperties then
  begin
    lvPropManagment.Items.Clear;
//    for i := 0 to Modules.Count - 1 do
//      EnumModuleClasses(TComponent(Modules[i]), EnumClasses);
    for i := 0 to EditorList.Count - 1 do
    begin
      S := EditorList[i];
      LI := lvPropManagment.Items.Add;
      LI.Caption := S;
      j := pos('.', S);
      S := copy(S, 1, j -1);
      LI.Checked := GetClass(S) <> nil;
    end;
  end;
end;

class procedure TfrmOptions.SaveToReg(ARegPath, ARegVal: PChar;
  AList: TStrings);
var S : string;
begin
  with TRegistry.Create do
  try
    OpenKey(string(ARegPath), True);
    S := AList.Text;
    WriteBinaryData(string(ARegVal), pointer(S)^, Length(S));
  finally
    Free;
    SetLength(S, 0);
  end;
end;

end.
